zoukankan      html  css  js  c++  java
  • CodeForces 986A Fair(BFS)

    A. Fair
    time limit per test
    2 seconds
    memory limit per test
    512 megabytes
    input
    standard input
    output
    standard output

    Some company is going to hold a fair in Byteland. There are nn towns in Byteland and mm two-way roads between towns. Of course, you can reach any town from any other town using roads.

    There are kk types of goods produced in Byteland and every town produces only one type. To hold a fair you have to bring at least ssdifferent types of goods. It costs d(u,v)d(u,v) coins to bring goods from town uu to town vv where d(u,v)d(u,v) is the length of the shortest path from uuto vv. Length of a path is the number of roads in this path.

    The organizers will cover all travel expenses but they can choose the towns to bring goods from. Now they want to calculate minimum expenses to hold a fair in each of nn towns.

    Input

    There are 44 integers nnmmkkss in the first line of input (1n1051≤n≤1050m1050≤m≤1051skmin(n,100)1≤s≤k≤min(n,100)) — the number of towns, the number of roads, the number of different types of goods, the number of different types of goods necessary to hold a fair.

    In the next line there are nn integers a1,a2,,ana1,a2,…,an (1aik1≤ai≤k), where aiai is the type of goods produced in the ii-th town. It is guaranteed that all integers between 11 and kk occur at least once among integers aiai.

    In the next mm lines roads are described. Each road is described by two integers uu vv (1u,vn1≤u,v≤nuvu≠v) — the towns connected by this road. It is guaranteed that there is no more than one road between every two towns. It is guaranteed that you can go from any town to any other town via roads.

    Output

    Print nn numbers, the ii-th of them is the minimum number of coins you need to spend on travel expenses to hold a fair in town ii. Separate numbers with spaces.

    Examples
    input
    Copy
    5 5 4 3
    1 2 4 3 2
    1 2
    2 3
    3 4
    4 1
    4 5
    
    output
    Copy
    2 2 2 2 3 
    
    input
    Copy
    7 6 3 2
    1 2 3 3 2 2 1
    1 2
    2 3
    3 4
    2 5
    5 6
    6 7
    
    output
    Copy
    1 1 1 2 2 1 1 
    
    Note

    Let's look at the first sample.

    To hold a fair in town 11 you can bring goods from towns 11 (00 coins), 22 (11 coin) and 44 (11 coin). Total numbers of coins is 22.

    Town 22: Goods from towns 22 (00), 11 (11), 33 (11). Sum equals 22.

    Town 33: Goods from towns 33 (00), 22 (11), 44 (11). Sum equals 22.

    Town 44: Goods from towns 44 (00), 11 (11), 55 (11). Sum equals 22.

    Town 55: Goods from towns 55 (00), 44 (11), 33 (22). Sum equals 33.

    题意:有n个城镇,和m条路,每个城镇生产一种物品(总共有k种),问你将s种不同的物品运到x城镇的最短距离。(1<=x<=n)。

    思路: 因为K只有100,所以我们计算对于第k种物品运到所有城镇的最短距离,最后将到x城镇的k种物品从小到大排序,求最小的s种。

    #include<iostream>
    #include<cstring>
    #include<cmath>
    #include<cstdlib>
    #include<cstdio>
    #include<algorithm>
    #include<string>
    #include<map>
    #include<queue>
    #define ll long long
    using namespace std;
    const int maxn=401000;
    queue<int> q;
    int l=0,n,m,s,k,x,y;
    int link[maxn],first[maxn],dis[maxn],ne[maxn],f[maxn/4][110],a[maxn],b[110],vis[maxn];
    void add(int x,int y)
    {
    	link[++l]=y;ne[l]=first[x];first[x]=l;
    }
    void bfs()
    {
    	while(!q.empty())
    	  {
    	  	int u=q.front();
    	  	q.pop();
    	  	for(int i=first[u];i;i=ne[i])
    	  	   {
    	  	   	int v=link[i];
    	  	   	if(dis[v]>dis[u]+1&&vis[v])
    	  	   	  {
    	  	   	  	dis[v]=dis[u]+1;
    	  	   	  	q.push(v);
    			  }
    		   }
    	  }
    }
    using namespace std;
    int main()
    {
    	scanf("%d%d%d%d",&n,&m,&k,&s);
    	for(int i=1;i<=n;i++) scanf("%d",&a[i]);
    	for(int i=1;i<=m;i++) 
    	    {
    	    scanf("%d%d",&x,&y);
    		add(x,y);add(y,x);
    		}
    	for(int i=1;i<=k;i++)
    	   {
    	   	while(!q.empty()) q.pop();
    	   	for(int j=1;j<=n;j++)
    	   	   if(a[j]==i) dis[j]=0,vis[j]=0,q.push(j);
    	   	   else dis[j]=12345678,vis[j]=1;
    	   	bfs();
    	   	for(int j=1;j<=n;j++) f[j][i]=dis[j]; 
    	   } 
    	for(int i=1;i<=n;i++)
    	   {
    	   	for(int j=1;j<=k;j++) b[j]=f[i][j];
    	   	sort(b+1,b+1+k);
    	   	int ans=0;
    	   	for(int j=1;j<=s;j++) ans+=b[j];
    	   	if(i!=n)printf("%d ",ans);else printf("%d
    ",ans);
    	   }
    }



  • 相关阅读:
    SpringBoot | Thymeleaf | 局部更新
    面试 | 冒泡排序优化
    JSP && Servlet | AXIS 0配置 入门
    155. 最小栈
    idea | 命名空间改过后重新导入项目方法
    Java | 基础归纳 | Map.Entry<String, String>
    08_Azkaban案例实践1_Command单一job示例
    07_Azkaban工作流调度器简介及其安装
    06_工作流调度器概述
    05_ Flume多级Agent之间串联案例
  • 原文地址:https://www.cnblogs.com/The-Pines-of-Star/p/9878829.html
Copyright © 2011-2022 走看看